//------------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop

#define BUILD_DLL

#include "moduleCode.h"

#include <string>

using namespace std;

// You can use counters or whatever to keep track of calls the way you want :)
int iTotalCalls = 0;

string IntToSTDStr(int iValue)
{
  char szBuf[40]="";
  sprintf(szBuf,"%d",iValue);
  return(szBuf);
}

//------------------------------------------------------------------------------
// This is exposed to the outside world, it MUST be called at least once
void __stdcall CIDCustomPlugin( CID_CB_DATA *pData )
{
  try
  {
    if(pData == NULL)
    {
      throw "Invalid NULL CID Pointer!";
    }

    iTotalCalls++;

    string sMsg = string("SUCCESS getting CallerID info: ") + (string)pData->szName_m +
                  string(", ") + (string)pData->szNumber_m + string(" for a total of: ") +
                  IntToSTDStr(iTotalCalls);

    MessageBox(NULL,sMsg.c_str(),"SUCCESS",MB_OK);

  }
  catch(const char *ex)
  {
    string sMsg = string("Internal error in [CIDCustomPlugin] msg: ") + (string)ex;
    MessageBox(NULL,sMsg.c_str(),"ERROR",MB_OK);
  }
  catch(const exception &ex)
  {
    string sMsg = string("Internal error in [CIDCustomPlugin] msg: ") + (string)ex.what();
    MessageBox(NULL,sMsg.c_str(),"ERROR",MB_OK);
  }
  catch(...)
  {
    string sMsg = string("UNKNOWN Internal error in [CIDCustomPlugin].");
    MessageBox(NULL,sMsg.c_str(),"ERROR",MB_OK);
  }
}

//------------------------------------------------------------------------------
#pragma argsused

int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  return 1;
}

//------------------------------------------------------------------------------

